
LSOF(8)             UNIX Programmer's Manual              LSOF(8)

NAME
     lsof - list open files

SYNOPSIS
     lsof [ -abCdjhHlmnNoOPstTUw ] [ -c c ] [ -D d ] [ -g l ] [
     -i i ] [ -k k ] [ -p l ] [ -S t ] [ -u l ] names

DESCRIPTION
     Lsof revision 3.25 lists information about files opened by
     processes for the following Unix dialects:

          AIX 3.2.4, 3.2.5, and 4.1 for the IBM RISC/System 6000
          DC/OSx 1.1 for Pyramid ES, Nile, and S series
          DYNIX 3.0.12 (Purdue version) for the Sequent Symmetry
          EP/IX 2.1.1 for the CDC 4680
          FreeBSD 1.1.5.1 and 2.0 for Intel-based systems
          HP-UX 8.x and 9.x for HP systems
          IRIX 4.0.5H, 5.2, 5.3, and 6.0 for SGI systems
          Linux 1.0.9, 1.1.47, 1.1.61, and 1.1.64 for Intel-based
               systems
          Motorola V/88 for R32V3, R40V4.2, and R40V4.3 M88K systems
          NetBSD 1.0 and 1.0A for Intel and SPARC-based systems
          NEXTSTEP 2.1 and 3.[0123], all architectures
          Novell UnixWare 1.1, 1.1.1, and 1.1.2 for Intel-based
               systems
          OSF/1 1.3, 2.0, 3.0, and 3.2 for DEC Alpha
          RISCos 4.52 for MIPS R2000-based systems
          SCO Open Desktop or Open Server 1.1 and 3.0 for
               Intel-based systems
          Solaris 2.[1234]
          SunOS 4.1.[1234]
          Ultrix 2.2, 4.2, 4.3, and 4.4 for DEC RISC and VAX

     An open file may be a regular file, a directory, a block
     special file, a character special file, an executing text
     reference, a library, a stream or a network file (Internet
     socket, NFS file or Unix domain socket.) A specific file or
     all the files in a file system may be selected by path.

     Lsof may work on other Unix dialects - e.g., AIX 3.2.3,
     EP/IX 1.4.3, FreeBSD 1.0e, HP-UX 7.x, IRIX 5.1.1, NEXTSTEP
     2.[01], and SunOS 4.1 - but has not been tested on them.

OPTIONS
     In the absence of any options, lsof lists all open files
     belonging to all active processes.

     If any list request option is specified, other list requests
     must be specifically requested - e.g., if -n is specified
     for the listing of Internet and x.25 (HP-UX [89].x) network
     files, NFS files won't be listed unless -N is also speci-
     fied; or if a user list is specified with the -u option,
     Internet and x.25 (HP-UX [89].x) network files and Unix
     domain socket files, belonging to users not in the list,
     won't be listed unless the -n and -U options are also speci-
     fied.

     Normally list options that are specifically stated are ORed
     - i.e., specifying the -n and -ufoo options produces a
     listing of all network files OR files belonging to processes
     owned by user ``foo''.  The -a option may be used to AND the
     selections.  For example, specifying -a, -n, and -ufoo pro-
     duces a listing of only network files that belong to
     processes owned by user ``foo''.

     Caution: the -a option causes all list selection options to
     be ANDed; it can't be used to cause ANDing of selected pairs
     of selection options by placing it between them, even though
     its placement there is acceptable.  Wherever -a is placed,
     it causes the ANDing of all selection options.

     Network addresses, specified with the -i option, are joined
     in a single ORed set before they participate in AND opera-
     tions.  Thus, for example, specifying -i@aaa.bbb,
     -i@ccc.ddd, -a, and -ufff will select the listing of files
     that belong to login ``fff'' AND have network connections to
     either host aaa.bbb OR ccc.ddd.

     -a       This option causes list selection options to be
              ANDed, as described above.

     -b       This option causes lsof to avoid kernel functions
              that might block - lstat(2), readlink(2), and
              stat(2).

              See the BLOCKS AND TIMEOUTS and AVOIDING KERNEL
              BLOCKS sections for information on using this
              option.

     -c c     This option specifies a memory (core) file, c, in
              place of /dev/kmem or /dev/mem.

     -C       This option disables the reporting of partial path
              name components from the kernel's name cache.  See
              the KERNEL NAME CACHE section for more information.

     -d       This option selects the production of error mes-
              sages about unreadable subdirectories of the /dev
              directory.  Under SunOS, for example, the /dev/lpd
              subdirectory is unreadable for security reasons.
              When building its cache of names and device numbers
              for devices, lsof skips unreadable subdirectories
              silently unless -d is specified.

     -D d     This option directs lsof's use of the device cache
              file.  (See the DEVICE CACHE FILE for more informa-
              tion on it.)

              -D may be followed by a function letter; it may
              optionally be followed by a path name.  Lsof recog-
              nizes these function letters:

                   b - build the device cache
                   i - ignore the device cache
                   r - read the device cache
                   u - read and update the device cache

              The i, r, and u functions may be followed by the
              device cache file's path.  The standard default is
              /tmp/.lsof dev cache, but this could have been
              changed when lsof was configured and compiled.
              (The output of the -h option shows the current
              default.)

              The -b function directs lsof to build a new device
              cache file at the default or specified path.

              The i function directs lsof to ignore the default
              device cache file and obtain its information about
              devices via direct calls to the kernel.

              The -r function directs lsof to read the device
              cache at the default or specified path, but
              prevents it from creating a new device cache file
              when none exists or the indicated one is improperly
              structured.

              The -u function directs lsof to read the device
              cache file at the default or indicated path, if
              possible, and to rebuild it, if necessary.  This is
              the default device cache file function.

     -g l     This option selects the listing of files for the
              processes whose process group IDentification
              numbers are in the comma-separated list `l' - e.g.,
              ``123'' or ``123,456''.  (There should be no spaces
              in the list.)

              This option automatically selects the -j option.

     -h       This option selects a brief usage (help) output
              list.

     -H       This option inhibits the conversion of network
              numbers to host names for network files.  Inhibit-
              ing conversion may make lsof run a little faster.
              It is also useful when host name lookup is not
              working properly.

     -i i     This option selects the listing of files any of
              whose Internet address matches the address speci-
              fied in i.  Multiple addresses may be specified
              with multiple -i options.  They are joined in a
              single ORed set before participating in any AND
              option selection.

              An Internet address is specified in the form:

              [protocol][@hostname|hostaddr][:service|port]

              where:
                   protocol is a protocol name - e.g., TCP.
                   hostname is an Internet host name.
                   hostaddr is an Internet host address in dot form.
                   service is an /etc/services name - e.g., smtp.
                   port is a port number.

              At least one address component - protocol, host
              specification, or port specification - must be sup-
              plied.  The `@' character, leading the host specif-
              ication, is always required; as is the `:', leading
              the port specification.  Specify either hostname or
              hostaddr.  Specify either service name or port
              number.  If service is specified, protocol must
              also be specified.  Use any case - lower or upper -
              for protocol.

              Here are some sample addresses:
                   TCP:25 - TCP and port 25
                   @1.2.3.4 - Internet host address 1.2.3.4
                   UDP:who - UDP who service port
                   TCP@vic.cc:513 - TCP, port 513 and host name vic.cc

     -j       This option enables the listing of process group
              IDentification numbers.  It is automatically
              selected when a list of process group ID numbers is
              specified with the -g l option.

              The letter for this option was chosen to match the
              equivalent option of some ps(1) incantations (DEC
              OSF/1, EP/IX, IRIX, SunOS), and not for any
              mnemonic value.

     -k k     This option specifies a kernel name list file, k,
              in place of /vmunix, /mach, /dynix, etc.  This
              option is not available under AIX on the IBM
              RISC/System 6000.

     -l       This option inhibits the conversion of user ID
              numbers to login names.  It is also useful when
              login name lookup is working improperly or slowly.

     -m       This option instructs lsof to stop execution
              immediately when it has to break a block during its
              scan of mounted file systems.  Normally lsof issues
              a warning message and continues.  The -t option may
              be specified to suppress warning messages.

     -n       This option selects the listing of Internet and
              x.25 (HP-UX [89].x) network files.

     -N       This option selects the listing of NFS files.

     -o       This option directs lsof always to display file
              offset.  It causes the SIZE/OFF output column title
              to be changed to OFFSET.

              The -o and -s options are mutually exclusive; they
              can't both be specified.  When neither is speci-
              fied, lsof displays whatever value - size or offset
              - is appropriate for the type of the file.

     -O       This option inhibits the ordering of process infor-
              mation by Process IDentification number.  As a
              side-effect, lsof will begin to deliver listing
              output sooner when this option is specified.

     -p l     This option selects the listing of files for the
              processes whose ID numbers are in the
              comma-separated list `l' - e.g., ``123'' or
              ``123,456''.  (There should be no spaces in the
              list.)

     -P       This option inhibits the conversion of port numbers
              to port names for network files.  Inhibiting the
              conversion may make lsof run a little faster.  It
              is also useful when host name lookup is not working
              properly.

     -s       This option directs lsof always to display file
              size.  It causes the SIZE/OFF output column title
              to be changed to SIZE.  If the file does not have a
              size, nothing is displayed.

              The -o and -s options are mutually exclusive; they
              can't both be specified.  When neither is
              specified, lsof displays whatever value - size or
              offset - is appropriate for the type of file.

     -S t     This option specifies different time-out seconds
              for kernel functions - lstat(2), readlink(2), and
              stat(2) - that might otherwise deadlock.  The
              minimum for t is two.

              See the BLOCKS AND TIMEOUTS section for more infor-
              mation.

     -t       This option specifies that lsof should produce
              terse output with process identifiers only and no
              header - e.g., so that the output may be piped to
              kill(1).  This option selects the -w option.

     -u l     This option selects the listing of files for the
              user whose login names or user ID numbers are in
              the comma-separated list `l' - e.g., ``abe'', or
              ``548,root''.  (There should be no spaces in the
              list.)

     -U       This option selects the listing of Unix domain
              socket files.

     -w       This option causes lsof to suppress all warning
              messages.  The -t option selects this option.

     names    These are path names of specific files to list.
              Symbolic links are resolved before use.

              If a name is the mount point of a file system or
              the device of the mount point of a file system,
              lsof will list all the files open on the file sys-
              tem.  If a name is the base name of a family of
              multiplexed files - e. g, AIX's /dev/pts - lsof
              will list all the associated multipled files on the
              device that are open - e.g., /dev/pts/1,
              /dev/pts/2, etc.

              If a name is a Unix domain socket name, lsof will
              search for it by the characters of the name alone -
              both as specified and as resolved from symbolic
              links.  When the socket uses a name that is a sym-
              bolic link to another, you must specify the name
              the socket uses.  However, if the socket uses the
              symbolic link's resolution, you may specify it or
              the symbolic link origination.  When asking lsof to
              search for a Unix domain socket name, be careful to
              specify its absolute path, just as it appears in
              kernel structures.  Specifying a relative path -
              e.g.  ./file - in place of the file's absolute path
              - e.g., /tmp/file - won't work because lsof must
              match the characters you specify with what it finds
              in the kernel structures associated with Unix
              domain sockets.

              If a name is none of the above, lsof will list any
              open files whose device and inode match that of the
              specified path name.

              If you have also specified the -b option, the only
              names you may safely specify are file systems for
              which your mount table supplies alternate device
              numbers.  See the AVOIDING KERNEL BLOCKS and ALTER-
              NATE DEVICE NUMBERS sections for more information.

SECURITY
     At the local administrator's discretion, lsof may be con-
     structed with its security option enabled or disabled.  When
     the security option is enabled, lsof will allow only the
     root user to list all open files.  The non-root user may
     list only open files of processes with the same user IDen-
     tification number as the real user ID number of the lsof
     process (the one that its user logged on with).  When the
     security option is disabled, anyone may list all open files.

     The last line of the help output, presented in response to
     the -h option, gives the security mode status.

     If the lsof user declares alternate kernel name list or
     memory files with the -c and -k options, lsof will check the
     user's authority to read them with access(2).  This prevents
     whatever special power lsof's modes might confer on it from
     letting it read files not normally accessible via the
     authority of the real user ID.

OUTPUT
     Lsof lists for each open file:

     COMMAND    contains the first nine characters of the name of
                the Unix command associated with the process.

     PID        is the Process IDentification number of the pro-
                cess.

     PGRP       is the process group IDentification number asso-
                ciated with the process.  It is only displayed
                when the -g l or -j options have been specified.

     USER       is the user ID number or login name of the user
                to whom the process belongs.  (See the -l
                option.)

     FD         is the File Descriptor number of the file or:

                     cwd  current working directory;
                     Lnn  library references;
                     ltx  shared library text (code and data);
                     Mxx  hex memory-mapped type number xx.
                     m86  DOS Merge mapped file;
                     mem  memory-mapped file;
                     pd   parent directory;
                     rtd  root directory;
                     txt  program text (code and data);
                     v86  VP/ix mapped file;

                FD is followed by one of these characters,
                describing the mode under which the file is open:

                     r for read access;
                     w for write access;
                     u for read and write access;
                     space if unknown (e.g., cwd or txt).

                The mode character is followed by one of these
                characters, describing the type of lock applied
                to the file:

                     r for read lock on part of the file;
                     R for a read lock on the entire file;
                     w for a write lock on part of the file;
                     W for a write lock on the entire file;
                     space if there is no lock.

     TYPE       is the type of the node associated with the file
                - e.g., GDIR, GREG, VDIR, VREG, etc.

                or ``dnet'' for a DECnet socket;

                or ``inet'' for an Internet domain socket;

                or ``lla'' for a HP-UX link level access file;

                or ``rte'' for an AF ROUTE socket;

                or ``sock'' for a socket of unknown domain;

                or ``unix'' for a Unix domain socket;

                or ``x.25'' for an HP-UX [89].x x.25 socket;

                or ``BLK'' for a block special file;

                or ``CHR'' for a character special file;

                or ``DIR'' for a directory;

                or ``FIFO'' for a FIFO special file;

                or ``LINK'' for a symbolic link file;

                or ``MPB'' for a multiplexed block file;

                or ``MPC'' for a multiplexed character file;

                or ``PCTL'' for a /proc control file;

                or ``PCUR'' for the current /proc process;

                or ``PDIR'' for a /proc directory;

                or ``PFIL'' for a executable /proc file;

                or ``PFPR'' for a /proc FP register set;

                or ``PGRP'' for a /proc group notifier file;

                or ``PIPE'' for an Ultrix 4.2 pipe;

                or ``PMEM'' for a /proc memory image file;

                or ``PNTF'' for a /proc process notifier file;

                or ``PORT'' for an Ultrix SYSV named pipe;

                or ``PREG'' for a /proc register file;

                or ``PSTA'' for a /proc status file;

                or ``REG'' for a regular file.

     DEVICE     contains the major and minor device numbers for a
                character special, block special, regular, direc-
                tory or NFS file (an HP-UX minor device number is
                listed in hexadecimal, as is a DEC OSF/1 minor
                device number larger than 99,999);

                or the protocol control block address of a DECnet
                (Ultrix 4.[23]), Internet, Unix, or x.25 (HP-UX
                [89].x) network file - the address that appears
                in the -A output from some netstat(1) programs;

                or ``memory'' for a memory file system node under
                OSF/1 on the DEC Alpha;

                or the address of the private data area of a
                Solaris socket stream.

                or a kernel reference address that identifies the
                file.  The kernel reference address may be used
                for FIFO's, for example.

                Usually only the lower thirty two bits of OSF/1
                DEC Alpha kernel addresses are displayed.

     SIZE/OFF or OFFSET
                is the size of the file or the file offset in
                bytes.  Lsof displays whatever value - size or
                offset - is appropriate for the type of the file.
                The file size is displayed in decimal; the offset
                is displayed in hexadecimal (with a leading
                ``0x'').

                If the -o option is specified, lsof always
                displays the file offset (or nothing if no offset
                is available) and labels the column OFFSET.  If
                the -s option is specified, lsof always displays
                the file size (or nothing if no size is avail-
                able) and labels the column SIZE.  The -o and -s
                options are mutually exclusive; they can't both
                be specified.

                If size is being displayed and the mode of a Unix
                domain socket is read-only, the receive buffer
                size is displayed; write-only, the write buffer
                size; read and write, the sum of the two buffer
                sizes.

                If size is being displayed and the mode of a
                Solaris TCP socket is read-only, the undelivered
                receive window size is displayed; write-only, the
                unacknowledged transmit window size; read and
                write, the sum of the two window sizes.

     INODE      is the inode number of a local file;

                or the inode number of an NFS file in the server
                host;

                or the Internet protocol type - e. g, ``TCP'';

                or ``STR'' for a stream;

                or ``CCITT'' for an HP-UX [89].x x.25 socket.

     NAME       is the name of the mount point and file system on
                which the file resides (Under IRIX 5.2 the
                appearance of ``(PIPE)'' identifies a pipe
                file.);

                or the name of a file specified in the names
                option (after any symbolic links have been
                resolved);

                or the name of a character special or block spe-
                cial device;

                or the local and remote Internet addresses of a
                network file (as numbers or names, depending on
                the -H and -P options);

                or the local and remote node and object addresses
                of a DECnet file (The node address appears as an
                area.node number pair if the -H option is speci-
                fied.);

                or the address or name of a Unix domain socket;

                or the local and remote mount point names of an
                NFS file;

                or ``STR'', followed by the stream name;

                or a stream character device name, followed by
                ``->'' and the stream name;

                or ``STR:'' followed by the SCO Unix stream dev-
                ice and module names, separated by ``->'';

                or the SunOS current working or root directory
                path name;

                system directory name, `` -- '', and as many com-
                ponents of the path name as lsof can read from
                the kernel's name cache for selected dialects
                (See the KERNEL NAME CACHE section for more
                information.);

                or ``PIPE->'', followed by a Solaris 2.3 kernel
                pipe destination address;

                or ``COMMON:'' for an IRIX (versions below 5.2)
                common file system entry;

                or ``COMMON:'', followed by the vnode device
                information structure's device name, for a
                Solaris 2.3 common vnode;

                or the address family, followed by a slash (`/'),
                followed by fourteen comma-separated bytes of a
                non-Internet raw socket address;

                or the HP-UX [89].x x.25 local address, followed
                by the virtual connection number (if any), fol-
                lowed by the remote address (if any);

                or ``(dead)'' for disassociated OSF/1 DEC Alpha
                files - typically terminal files that have been
                flagged with the TIOCNOTTY ioctl and closed by
                daemons;

                or ``r=count/bytes w=count/bytes'' for incomplete
                EP/IX 2.1.1 file structures (ones with no vnode
                or socket pointer), with
                     r signifying read statistics,
                     count giving the operation count,
                     bytes giving bytes transferred,
                     w signifying write statistics;

                or the Remote Host Facility local logical iden-
                tifier, local application name, remote logical
                identifier, and remote application name.

BLOCKS AND TIMEOUTS
     Lsof can be blocked by some kernel functions that it uses -
     lstat(2), readlink(2), and stat(2).  These functions are
     blocked in the kernel, for example, when the hosts where
     mounted NFS file systems reside become inaccessible.

     Lsof attempts to break these blocks with timers and child
     processes, but the techniques are not wholly reliable.  When
     lsof does manage to break a block, it will report the break
     with an error message.  The messages may be suppressed with
     the -t and -w options.

     The default timeout value may be displayed with the -h
     option, and it may be changed with the -S t option.  The
     minimum for t is two seconds, but you should avoid small
     values, since slow system responsiveness can cause short
     timeouts to expire unexpectedly and perhaps stop lsof before
     it can produce any output.

     When lsof has to break a block during its access of mounted
     file system information, it normally continues, although
     with less information available to display about open files.
     You can use the -m option to tell lsof to stop execution
     immediately when it has to break a block.

AVOIDING KERNEL BLOCKS
     You can use the -b option to tell lsof to avoid using kernel
     functions that would block.  Some cautions apply.

     First, using this option usually requires that your system
     supply alternate device numbers in place of the device
     numbers that lsof would normally obtain with the lstat(2)
     and stat(2) kernel functions.  See the ALTERNATE DEVICE
     NUMBERS section for more information on alternate device
     numbers.

     Second, you can't specify names for lsof to locate unless
     they're file system names.  This is because lsof needs to
     know the device and inode numbers of files listed with names
     in the lsof options, and the -b option prevents lsof from
     obtaining them.  Moreover, since lsof only has device
     numbers for the file systems that have alternates, its abil-
     ity to locate files on file systems depends completely on
     the availability and accuracy of the alternates.  If no
     alternates are available, or if they're incorrect, lsof
     won't be able to locate files on the named file systems.

     Third, if the names of your file system directories that
     lsof obtains from your system's mount table are symbolic
     links, lsof won't be able to resolve the links.  This is
     because the -b option causes lsof to avoid the kernel
     readlink(2) function it uses to resolve symbolic links.

     Finally, using the -b option causes lsof to issue warning
     messages when it needs to use the kernel functions that the
     -b option directs it to avoid.  You can suppress these mes-
     sages by specifying the -w option, but if you do, you won't
     see the alternate device numbers reported in the warning
     messages.

ALTERNATE DEVICE NUMBERS
     On some dialects, when lsof has to break a block because it
     can't get information about a mounted file system via the
     lstat(2) and stat(2) kernel functions, or because you speci-
     fied the -b option, lsof can obtain some of the information
     it needs - the device number and possibly the file system
     type - from the system mount table.  When that is possible,
     lsof will report the device number it obtained.  (You can
     suppress the report by specifying the -w option.)

     You can assist this process if your mount table is supported
     with an /etc/mtab or /etc/mnttab file that contains an
     options field by adding a ``dev=xxxx'' field for mount
     points that do not have one in their options strings.

     The ``xxxx'' portion of the field is the hexadecimal value
     of the file system's device number.  (Consult the st dev
     field of the output of the lstat(2) and stat(2) functions
     for the appropriate values for your file systems.) Here's an
     example from an SGI IRIX 5.2 /etc/mtab for a file system
     remotely mounted via NFS:

          ... nfs rw,grpid,intr,nodevs,retry=6,dev=00100007 ...

     There's an advantage to having ``dev=xxxx'' entries in your
     mount table file, especially for file systems that are
     mounted from remote NFS servers.  When a remote server
     crashes and you want to identify its users by running lsof
     on one of its clients, lsof probably won't be able to get
     output from the lstat(2) and stat(2) functions for the file
     system.  If it can obtain the file system's device number
     from the mount table, it will be able to display the files
     open on the crashed NFS server.

     Some dialects that do not use an ASCII /etc/mtab or
     /etc/mnttab file for the mount table may still provide an
     alternative device number in their internal mount tables.
     This includes AIX, DEC OSF/1, FreeBSD, NetBSD, and Ultrix.
     Lsof knows how to obtain the alternative device number for
     these dialects and uses it when its attempt to lstat(2) or
     stat(2) the file system is blocked.

     If you're not sure your dialect supplies alternate device
     numbers for file systems from its mount table, use this lsof
     incantation to see if it reports any alternate device
     numbers:

          lsof -b

     Look for standard error file warning messages that begin
     ``assuming "dev=xxxx" from ...''.

KERNEL NAME CACHE
     Lsof is able to examine the kernel's name cache on some
     dialects and extract recently used path name components from
     it.  Lsof reports the ones it finds in the NAME column,
     starting with the file system name, followed by a space, two
     `-' characters, another space, and the name components it
     has located, separated by the `/' character.

     Lsof can report path name components for these dialects:

          DYNIX 3.0.12 (Purdue version)
          EP/IX 2.1.1
          FreeBSD 1.1.5.1 and 2.0
          HP-UX 9.x
          Motorola V/88 R40V4.2
          NetBSD 1.0 and 1.0A
          NEXTSTEP 3.[0123]
          OSF/1 2.0, 3.0, and 3.2
          SGI IRIX 5.3
          Solaris 2.[34]
          SunOS 4.1.[23]
          Ultrix 2.2, 4.2, and 4.3

     Lsof can't report path name components for these dialects:

          AIX 3.2.4, 3.2.5, and 4.1
          DC/OSx 1.1
          Linux 1.0.9, 1.1.47, 1.1.61, and 1.1.64
          Motorola V/88 R32V3
          Novell UnixWare 1.1, 1.1.1, and 1.1.2
          SCO Open Desktop or Open Server 1.1 and 3.0
          SGI IRIX 4.0.5H, 5.2, and 6.0

     Lsof may be able to report path name components for these
     dialects, but the code hasn't been tested on them:

          HP-UX 8.x
          NEXTSTEP 2.1
          OSF/1 1.3
          Solaris 2.[12]
          SunOS 4.1.[14]
          Ultrix 4.3 and 4.4

     If you want to know why lsof can't report path name com-
     ponents for some dialects, consult section 3.1 of the 00FAQ
     file of the lsof distribution.

DEVICE CACHE FILE
     Examining all members of the /dev node tree with stat(2)
     functions can be time consuming.  What's more, the informa-
     tion that lsof needs - device number, inode number, and path
     - rarely changes.

     Consequently, at revision 3.19 lsof has begun maintaining an
     ASCII text file of cached /dev information.  The standard
     path for the device cache file is /tmp/.lsof dev cache, but
     the local system administrator may change the path when lsof
     is compiled, or the default path for some systems my be
     slightly shorter.  (Consult the output of the -h option for
     the current default path.)

     The -D option provides some control over the cache.  It
     allows you to request that the cache file be built in a
     specific location (b[path]); ignored (i); read but not
     rebuilt (r[path]); or read and rebuilt (u[path]).

     The u function is the default, using the default device
     cache file path of /tmp/.lsof dev cache.  This function
     tells lsof to attempt to read and use the device cache file.
     If it can't read the file, it will read information from the
     kernel with stat(2) function calls, then write an updated
     version of the file.

     The device cache file is stored by default in /tmp with read
     and write permission for owner, group, and user, so any lsof
     call can access or rebuild it.  (You can change the device
     cache file path with the optional path suffix of the b, r,
     and u functions.)

     Lsof can detect that the file has been accidentally or mali-
     ciously modified by a number of sanity checks, including a
     sixteen bit Cyclic Redundancy Check (CRC) sum of the file's
     contents.  When lsof senses something wrong with the file,
     it will attempt to remove the current one and create a new
     copy.

     On those rare occasions when a new device is added to the
     system, the device cache file may need to be recreated.
     Since lsof compares the mtime of the device cache file with
     the mtime and ctime of the device directory (usually /dev)
     it often can detect that a new device has been added; in
     that case lsof issues a warning message and rebuilds the
     device cache file, depending on the function specified in
     the -D option.

     If lsof doesn't update the cache file when you believe it
     should, use the b function to make it recreate the file.

DIAGNOSTICS
     Errors are identified with messages on the standard error
     file.

     Lsof returns a one (1) if any error was detected, including
     the failure to locate any names.  It returns a zero (0) if
     no errors were detected and if it was able to list informa-
     tion about all the specified names.

EXAMPLES
     To list all open files, use:

          lsof

     To list all open Internet, x.25 (HP-UX [89].x), and Unix
     domain files, use:

          lsof -n -U

     To list all files using any protocol on port 513 of host
     wonderland.cc.purdue.edu, use:

          lsof -i @wonderland.cc.purdue.edu:513

     To list all files using any protocol on any port of
     mace.cc.purdue.edu (cc.purdue.edu is the default domain),
     use:

          lsof -i @mace

     To list all open files for login name ``abe'', user ID 1234,
     process 456, process 123 and process 789, use:

          lsof -p 456,123,789 -u 1234,abe

     To list all open files on device /dev/hd4, use:

          lsof /dev/hd4

     To find the process that has /u/abe/foo open, use:

          lsof /u/abe/foo

     To send a SIGHUP to the processes that have /u/abe/bar open,
     use:

          kill -HUP `lsof -t /u/abe/bar`

     To find any open file, including an open Unix domain socket
     file, with the name /dev/log, use:

          lsof /dev/log

     To find processes with open files on the NFS file system
     named /nfs/mount/point whose server is inaccessible, and
     presuming your mount table supplies the device number for
     /nfs/mount/point, use:

          lsof -b /nfs/mount/point

     To do the preceding search with warning messages suppressed,
     use:

          lsof -bw /nfs/mount/point

     To ignore the device cache file, use:

               lsof -Di

     To read the device cache file named Xyz in the current
     directory and update it, if necessary, use:

               lsof -DuXyz

BUGS
     Since lsof reads kernel memory in its search for open files,
     rapid changes in kernel memory may produce unpredictable
     results.

     The use of alternate kernel (with the -k option) and alter-
     nate memory (with the -c option) files has only been tested
     under SunOS and the Purdue version of Sequent DYNIX.  Use of
     an alternate memory file may require a mapping of kernel
     virtual to physical addresses that lsof does not provide.

     Lsof can only interpret AIX loader dependency references
     that are contained in the user structure - some reside out-
     side it and can't be obtained by known methods for reading
     kernel memory.  When lsof can't read loader dependency
     information, it displays the loader dependency index and its
     kernel segment address.

     The lock status character (following the file descriptor) is
     derived under AIX from a test of only the first filock
     structure of the gnode (see <sys/flock.h> and
     <sys/gnode.h>).

     Lsof can't search for files with restrictive access permis-
     sions by name unless it is installed with root set-UID per-
     mission.  Otherwise it is limited to searching for files to
     which its user or its set-GID group (if any) has access per-
     mission.

     Lsof startup time is long on dialects where scanning the
     /dev (or /devices) directory and the mount table are slow
     operations.  Where possible - e.g., when the listing of only
     network files is requested - the scans are avoided or
     deferred.  When the device cache file is in use, scanning
     /dev is avoided once the cache file has been written.

     If there are files or subdirectories in /dev that lsof can't
     lstat(2), stat(2), or read, it will ignore them without
     complaint, unless the -d option is selected.  Whether lsof
     complains or not, it is unable to report major and minor
     device numbers for the entries it can't access.

     Lsof ignores SunOS loop-back mounts.  It can't distinguish
     between loop-back file systems and real ones, using inode
     and device numbers.

     The display of the destination address of a raw socket
     (e.g., for ping) depends on the Unix operating system.  Some
     dialects store the destination address in the raw socket's
     protocol control block, some do not.

     Lsof can't always represent Solaris and SunOS device numbers
     in the same way that ls(1) does.  For example, the major and
     minor device numbers that the lstat(2) and stat(2) functions
     report for the directory on which CD-ROM files are mounted
     (typically /cdrom) are not the same as the ones that it
     reports for the device on which CD-ROM files are mounted
     (typically /dev/sr0).  (Lsof reports the directory numbers.)

     The system to which the Ultrix 2.2 port was directed is a
     local one that has been extensively updated with network
     features from the 4.3BSD Tahoe and Reno releases, so it may
     not match a standard Ultrix 2.2 system, if there is any such
     system still in use.

     ADVFS file support has not been tested for version 1.x of
     DEC OSF/1.

     The support for /proc file systems is available only for BSD
     and OSF dialects, Linux, and dialects derived from SYSV R4 -
     e.g., FreeBSD, IRIX 5.[23], NetBSD, Solaris, V/88
     R40V4.[23], UnixWare.  One SYSV R4 exception is EP/IX 2.1.1,
     where I have been unable to overcome conflicts between its
     svr3 and svr4 environments to build an lsof with /proc file
     system support.  Some /proc file items - device number,
     inode number, and file size - are unavailable in some
     dialects.

     No text (txt) file descriptors are displayed for Linux
     1.1.47 processes.  All entries for files other than the
     current working directory, the root directory, and numerical
     file descriptors are labeled mem descriptors.

FILES
     /dev/kmem               kernel virtual memory device

     /dev/mem                physical memory device

     /dev/swap               system paging device

     /tmp/.lsof dev cache    lsof's device cache file

AUTHORS
     Lsof was written by Victor A. Abell of the Purdue University
     Computing Center (PUCC), starting from the fstat and ofiles
     programs.  Anthony Shortland <Anthony.Shortland@FMR.com>
     produced the Pyramid DC/OSx 1.1 support.

     Vic acknowledges his debt to the work of Dan Bernstein,
     Michael ``Ford'' Ditto, Tom Dunigan, Alexander Dupuy, Vik
     Lall, Ray Moody, C. Spencer, Michael Spitzer and those who
     wrote Berkeley's fstat program, all contributors to lsof's
     predecessors.  Vic thanks Doug McKenzie for his HP-UX proc-
     tor program and Rich Kulawiec for pointing it out.

     Finally, Vic is grateful to David Addison, Marc Auslander,
     Ade Barkah, Anthony Baxter, John Beacom, Bruce Beare, Dave
     Bianchi, Achim Bohnet, Mark Bonsack, Bill Bormann, Michael
     Bryan, Bernt Christandl, Hans Petter Christiansen, Axel
     Clauberg, Jim Cooper, Dave Curry, Ian Darwin, Casper Dik,
     Greg Earle, Doug Eldred, Robert Ehrlich, Scott Ellentuch,
     Mike Feldman, Mike Fraser, Terry Friedrichsen, David
     DiGiacomo, Garner Halloran, Adam Hammer, Charles Hannum,
     Steinar Haug, Paul Hite, J. Nelson Howell, John Jackson,
     Kurt Jaeger, Carl Johnson, Dion Johnson, Pasi Kaara, Frank
     Kaefer, Claus Kalle, Steve Kirsch, Przemek Klosowski, Paul
     Kranenburg, Alex Kreis, Markus Lautenbacher, Steve Lacey,
     Marty Leisner, Stuart Levy, Wendy Lin, Friedel Loinger, Pete
     Lord, Bela Lubkin, Horst Luehrsen, Andreas Luik, Michael
     Mackenzie, Lawrence MacIntyre, Benson Margulies, Claude Mar-
     inier, Fletcher Mattox, Dale McCluskey, Sean McDermott,
     Dwight McKay, William McVey, Jeffrey Mogul, Dave Morrison,
     Pat Myrto, Allan Nathanson, Chance Neale, Dave Olson, Mark
     Peek, Ezra Peisach, Nathan Peterson, Dominique Petitpierre,
     Francois Pinard, Alex Podlecki, Philippe-Andre Prindeville,
     Tim Ramsey, Chris Schanzle, Hendrik G. Seliger, Anthony
     Shortland, John Silva, Gerry Singleton, Dave Stevens, Jeff
     Stewart, Andreas Stolcke, Dale Talcott, Andy Thomas, Chris
     Timmons, Zdenko Tomasic, Linus Torvalds, Robert Vernon, Jos
     Vos, Patrick Wolfe, James Woodward, and Ron Young for their
     help in developing and improving lsof.

SEE ALSO
     access(2), ff(1), fstat(8), fuser(1), kill(1), lstat(2),
     netstat(1), ofiles(8L), ps(1), readlink(2), stat(2).

